/**
  ******************************************************************************
  * @file    BF8915A.h
  * @version V1.1.4
  * @date    2021-12-20
  * @brief   This file provides the BF8915A functions(ļṩBF8915A).
 */
#ifndef __BF8915A_H__
#define __BF8915A_H__

//#include "kit_sys.h"

#include <stdlib.h>
#include "stdint.h"
#include <stdio.h>

#include "gpio_manager.h"
typedef enum
{
	FALSE = 0U,
	TRUE =  1U,
}BOOLEAN_Type;

typedef unsigned char  BOOLEAN;
//typedef BOOLEAN_Type BOOLEAN;//͵ֵstdboolжboolֵͻֲ

extern BOOLEAN	 isospi_reverse;//ıñʵ־ջSPIͨš
                                //FALSE:ԵͨţSDKеSPI1ΪͨţSPI1ջӵĵһICIC0;
                                //TURE: ԵķͨţSDKеSPI2ΪԷͨţҲSPI1ջӵĵһICIC0

extern const uint16_t crc15Table[256];//precomputed CRC15 Table(Ԥ15λѭУֵı)


#define TOTAL_IC						100U	 //ջϴIC(8915A)ĸʵ޸Ĵ


#define CELL_CHANNELS				16U	 //16ͨ
#define GPIO_CHANNELS				9U	 //8GPIO + 1VD33T
#define STAT_CHANNELS				8U	 //816λĵѹ
#define NUM_CV_REG					6U	 //Cell Voltage Register Group(صѹĴ) A B C D E F6
#define NUM_GOIO_REG				3U	 //Auxiliary Register Group(GPIOxѹϢ)A B C 3
#define NUM_STAT_REG				4U	 //Status Register Group(״̬Ĵ) A B C D4

//ADCתĵѡ
#define CSEL_CH_ALL 				0U
#define CSEL_CH_1and9 			1U
#define CSEL_CH_2and10 			2U
#define CSEL_CH_3and11 			3U
#define CSEL_CH_4and12 			4U
#define CSEL_CH_5and13 			5U
#define CSEL_CH_6and14 			6U
#define CSEL_CH_7and15 			7U
#define CSEL_CH_8and16			8U

//ADCתGPIOѡ
#define GSEL_CH_ALL 				0U   //GPIO0~GPIO7,VD33T
#define GSEL_CH_GPIO0 			1U
#define GSEL_CH_GPIO1 			2U
#define GSEL_CH_GPIO2 			3U
#define GSEL_CH_GPIO3 			4U
#define GSEL_CH_VD33T 			5U
#define GSEL_CH_GPIO4 			6U
#define GSEL_CH_GPIO5 			7U
#define GSEL_CH_GPIO6 			8U
#define GSEL_CH_GPIO7 			9U

//ADCתڲѡ	STSEL
#define STSEL_CH_ALL 				0U   //ڲVD33VHVD7VD5VD4VTEMPVREF2VREF_LP
#define STSEL_CH_VD33 			1U
#define STSEL_CH_VH 				2U
#define STSEL_CH_VD7 				3U
#define STSEL_CH_VD5 				4U
#define STSEL_CH_VD4				5U
#define STSEL_CH_VTEMP 			6U
#define STSEL_CH_VREF2 			7U
#define STSEL_CH_VREF_LP 		8U

//ADCƵѡ
#define CLKSEL_2M 					1U
#define CLKSEL_4M                   0U  //ADCWΪ4096(ADCOWָʱʹ,ָʹ)

//CFGAR2
#define OSR_SEL 		        FALSE	//0U ADCΪ64128256512(ָֹͨOSRѡ)
#define OSR_SEL_DISABLE         TRUE    //1U ADCWΪ4096(ADCOWָʱʹãָʹ)
//ADCѡ
#define OSR_64 				        0U
#define OSR_128 				    1U
#define OSR_256 				    2U
#define OSR_512_4096 			    3U
	
//ŵ	
#define DISCP_DISABLE				0U   //DISCP=0ӦĵغڵĵرʱSŵķŵ״̬ʹ
#define DISCP_ENABLE				1U   //DISCP=1ڵزڼSŵķŵ״̬ı	
	
//Բģʽѡ	
#define SELFTEST_6666 			0U   //ST = 0,0x6666
#define SELFTEST_9999 			1U   //ST = 1,0x9999
	
//ģʽѡ	
#define MNMOD_DISABLE				0U   //ģʽָЧ
#define MNMOD_1						1U   //ģʽ1,ģԴʱӴ򿪣pll_100m
#define MNMOD_2						2U   //ģʽ2,ģԴʱӴ򿪣pll_100mر
#define MNMOD_3						3U   //ģʽ3,͹ļ⣬ģԴʱӹر

//ģʽ
#define	STRMN_ENABLE				1U   //ģʽ
#define STRMN_DISABLE				0U   //رռģʽ

//GPIO߼Դѡ
#define	DOWN_GPIO_UP				0U   //Դ
#define DOWN_GPIO_DOWN			1U   //Դ

//ŵżѡ
#define	OESEL_ODD						0U   //
#define OESEL_EVEN					1U   //ż

//⿪ܿź2
#define	BLEN_ON							1U   //
#define BLEN_OFF						0U   //ر

/***bit[12:9]λ***/
#define CMD_ADCV						0x01U
#define CMD_ADCOW						0x02U
#define CMD_CVST						0x03U
#define CMD_ADOL						0x04U
#define CMD_ADGP						0x05U
#define CMD_ADGOW						0x06U
#define CMD_GPST						0x07U
#define CMD_ADSTAT					    0x08U
#define CMD_STATST					    0x09U
#define CMD_ADCVGP					    0x0aU
#define CMD_ADCVVH					    0x0bU
#define CMD_MNT							0x0cU
#define CMD_STRBL						0x0dU

/***üĴ***/
#define RDCFGA							0x05U
#define RDCFGB							0x06U
#define RDCFGC							0x07U
#define RDCFGD							0x08U

/***صѹĴӦ***/
#define CVAR								0x01U    //	 0x01 + 0x08 = 0x09U	BF8915A_rdcv_regõ
#define CVBR								0x02U    //	 0x02 + 0x08 = 0x0AU
#define CVCR								0x03U    //	 0x03 + 0x08 = 0x0BU
#define CVDR								0x04U    //	 0x04 + 0x08 = 0x0CU
#define CVER								0x05U    //	 0x05 + 0x08 = 0x0DU
#define CVFR								0x06U    //	 0x06 + 0x08 = 0x0EU
/***GPIOGѹ***/
#define GVAR								0x01U		 //  0x01 + 0x0E = 0x0FU BF8915A_rdgv_regõ
#define GVBR								0x02U		 //  0x02 + 0x0E = 0x10U
#define GVCR								0x03U		 //  0x03 + 0x0E = 0x11U
/***״̬ĴRDSTAT***/              
#define STATA								0x01U		 //	 0x01 + 0x11 = 0x12U
#define STATB								0x02U		 //	 0x02 + 0x11 = 0x13U
#define STATC								0x03U		 //	 0x03 + 0x11 = 0x14U
#define STATD								0x04U		 //	 0x04 + 0x11 = 0x15U

#define REG_ALL 						0x00U
#define NUM_RX_BYT  				    0x08U	   //յݵֽ6+2PEC()

typedef struct//Register data structure(Ĵݽṹ).
{
  uint8_t tx_data[6];				  //ÿĴbyte(ֽ)ԪظΪ6
  uint8_t rx_data[8];				  //յļĴ 6 byte(ֽ)+ 2 byte PEC()
  uint8_t rx_pec_match; 	  	//Ķȡcmd(ָ)ڼ⵽PEC()
}Reg_TypeDef;

typedef struct//ConfigA data structure(Aݽṹ).
{
	uint8_t 	gpio_pd_en;				//GPIOʹܣÿһλӦһIO
	uint8_t 	gpio_analog_en;		    //GPIO0~7ģʽѡ		0:ģ		1:ͨGPIO
	BOOLEAN 	adc_init_mode;	
	BOOLEAN 	rsvd2;				    //λԶ0
	BOOLEAN 	rsvd1;		        //λԶ0
	BOOLEAN 	osr_sel;					//ADCѡ  1:ADCΪ1024204840964096	 0:ADCΪ64128256512
	BOOLEAN 	refon;						//VREF1(׼ѹ) 1 :VREF1ϵֱWDT  0 :ADCת֮VREF1ر (Ĭ)
	uint16_t 	uv_th;						//Ƿѹֵ
	uint16_t 	ov_th;						//ѹֵ
	uint8_t   rx_pec_match;			//Ķȡcmd(ָ)ڼ⵽PEC()
}ConfigA_TypeDef;

typedef struct//ConfigB data structure(Bݽṹ).
{
	uint16_t 	dcc;							//ŵؿ1:Cell x Ŀ  0:رCell x Ŀ (Ĭ) 
	uint8_t 	bl_duty_sel;			//ռձѡ  ռձ=(BL_DUTY_SEL+1)*10%÷Χ10%~100%9ʱ100%
	uint8_t 	dcto;							//ŵ綨ʱֵ
	uint16_t 	vuv_bl_th;				//Ƿѹֵ
	BOOLEAN 	dtmen;						//Զ£DTMEN=1Ƿѹ(СVUV_BL)رշŵ翪أDTMEN=0ǷѹȽ
	uint8_t 	rx_pec_match; 		//Ķȡcmd(ָ)ڼ⵽PEC()
}ConfigB_TypeDef;

typedef struct//ConfigC data structure(Cݽṹ).
{
	uint16_t 	vuv_m_th;					//ģʽ£Ƿѹֵ
	uint16_t 	vov_m_th;					//ģʽ£ѹֵ
	uint16_t 	itov_m_th;				//ģʽ£ڲֵ
	uint16_t 	extov_m_th; 			//ģʽ£ⲿֵ
	uint8_t 	rx_pec_match; 		//Ķȡcmd(ָ)ڼ⵽PEC()
}ConfigC_TypeDef;

typedef struct//ConfigD data structure(Dݽṹ).
{
	uint16_t 	csel_m;						//ģʽ£صѹȽѡ 1:Ӧĵؾͻڼģʽ½йǷѹȽϣñ־λ
															// 															 	 0:Ӧĵؾͻڼģʽ²йǷѹȽϣñ־λ
	uint8_t 	gsel_m;						//ģʽ£GPIO0~7Ƚѡ
	BOOLEAN 	isospi_wake_t;		//isospi(ջSPI)ʱ䣬0:10us		1:20us
	BOOLEAN 	adc_rst_sel;			//1ͨADCλѡ0:вͨλADC1:ֻе1ͨλADC֮2~nͨλADC
	uint8_t 	time_sel_m;				//ģʽ£ʱʱãʱʱ=(TIME_SEL_M+1)*1s(2~64s)Сֵ1(2s)
	uint8_t 	adc_init_t2;			//ADC2~nͨADCʼʱ䣬(ADC_INIT_T2+1)*20us(20~320us)
	uint8_t 	adc_init_t1;			//ADC1ͨADCʼʱ(ADC_INIT_T1+1)*100us(100~1600us)
	BOOLEAN 	trim2_en;					//޵2ʹܣ1:ʹܣ0:ʹ
	BOOLEAN 	trim1_en;					//޵1ʹܣ1:ʹܣ0:ʹ
	uint8_t 	err_t_sel_m;			//ģʽ·쳣ϱļʱ  00:200ms01:400ms10:600ms11:800ms
	uint8_t 	vd33t_on_m;				//ģʽ£VREF1VD33Tʱ(5+VD33T_ON_M*10)msΧ5~155ms
	uint8_t 	rx_pec_match; 		//Ķȡcmd(ָ)ڼ⵽PEC()
}ConfigD_TypeDef;

typedef struct//Cell Voltage data structure(صѹݽṹ).
{
//Ϊ16ڵأЧΪ16
	uint16_t 	cellVoltage[16]; 
//ΪABCDEFصѹĴ
	uint8_t 	pec_match[6]; 		//Ķȡcmd(ָ)ڼ⵽PEC()
}CellVoltage_TypeDef;

typedef struct//AUX Reg Voltage Data structure(GPIOĴѹݽṹ)
{
	uint16_t 	gpioVoltage[9]; 	//GPIO Voltage Codes(ĴеG0V~G7V)GPIOABC(8GPIO + 1VD33T)
	uint8_t 	pec_match[3]; 		//Ķȡcmd(ָ)ڼ⵽PEC()
}GPIOReg_TypeDef;

typedef struct//Status Reg data structure(״̬Ĵݽṹ)
{
	uint16_t 	stat_codes[8];		//A two dimensional array of the stat voltage codes(ͳƵѹĶά)
	uint8_t  	uvOvFlags[4]; 		//byte array that contains the uv/ov flag data(uv/ov־ݵֽ)
	uint16_t 	cellUvFlag;				//Ƿѹ־λÿλ־ÿصǷѹ־λ
	uint16_t 	cellOvFlag;				//عѹ־λÿλ־ÿصĹѹ־λ
	uint8_t  	cfg_err;	 				//У־(żУECCУ)
	uint8_t  	pec_err;	 				//ָݵPECУ־
	uint8_t  	extov;		 				//ģʽ£ⲿ¶(gpio)±־
	uint8_t  	itov;			 				//ģʽ£ڲ¶(vtemp)±־
	uint8_t  	htov2;		 				//Ӳ¶(95)±־ 1:Ӳ¶ȹ£0:Ӳ¶Ȳ
	uint8_t  	htov1;     				//Ӳ¶(125)±־1:Ӳ¶ȹ£0:Ӳ¶Ȳ
	uint8_t  	mux_fail;  				//Խ 0 : ȷ		1: 
	uint8_t  	mode_state;				//ģʽ״̬Ĵ   00:standbyģʽ 01:ģʽ 10:ģʽ 11:λ(sleepģʽرʱӣܶ״̬)
	uint8_t  	rst_state; 				//λ־Ĵ
	uint8_t  	pec_match[4]; 		//Ķȡcmd(ָ)ڼ⵽PEC()
}StateReg_TypeDef;						//ABCDĸ״̬Ĵ

/***************************Ҫ޸ĵĺ********************************************
 *а
 *ƬѡCS      ::cs_low()cs_high()Է:cs_low_reverse()cs_high_reverse()
 *ʱ    :delay_us
 *SPIӿ     :SPI1_ReadWriteByteSPI2_ReadWriteByte
 *********************************END************************************************/

#define cs_low()						drv_gpio_set_pin_status(kGpioType_SPI1_Cs, kGpioStatus_Low);//ͨŵƬѡCSΪ͵ƽ
#define cs_high()						drv_gpio_set_pin_status(kGpioType_SPI1_Cs, kGpioStatus_High)//ͨŵƬѡCSΪߵƽ
#define cs_low_reverse()				drv_gpio_set_pin_status(kGpioType_SPI2_Cs, kGpioStatus_Low);//{PDout(8) = 0U;}//ԷͨŵƬѡCSΪ͵ƽ
#define	cs_high_reverse()				drv_gpio_set_pin_status(kGpioType_SPI2_Cs, kGpioStatus_High);//ԷͨŵƬѡCSΪߵƽ

//ʱ
extern void delay_us(uint32_t nus);

//TxData 8λ16λģSPI֮ǰȷ֡ʽ
extern uint8_t SPI1_ReadWriteByte(uint8_t TxData); 

//TxData 8λ16λģSPI֮ǰȷ֡ʽ
extern uint8_t SPI2_ReadWriteByte(uint8_t TxData); 

//Wake isoSPI up from idle state(ջSPIӿ״̬)
void wakeup_idle(uint8_t total_ic);

///Generic wakeup command to wake the BF8915A from sleep(BF8915A˯лѵͨû)
void wakeup_sleep(uint8_t total_ic);

//Writes an array of bytes out of the SPI port(ֽдSPI˿)
void spi_write_array(uint8_t len,uint8_t writeData[]);

//Generic function to write BF8915A commands. Function calculated PEC for tx_cmd data(дBF8915AͨúΪcmdݼ˼)
void BF8915A_cmd(uint8_t tx_cmd[2]);

//Generic function to write BF8915A commands and write payload data. Function calculated PEC for tx_cmd data(дBF8915AдЧغݵͨútx_cmdݵĺ)
void BF8915A_write(uint8_t total_ic ,uint8_t tx_cmd[2],uint8_t write_data[]);//Writes an array of data to the daisy chain	(һдջ)

//Issues a command onto the daisy chain and reads back 6*total_ic data in the rx_data array(ջضrx_dataе6IC(8915A))
uint8_t BF8915A_read(uint8_t total_ic,uint8_t tx_cmd[2],uint8_t *rx_data);

//Calculates and returns the CRC15(㲢15λѭУֵ)
uint16_t pec15_calc(uint8_t len,uint8_t *pecData);

//Write the BF8915A CFGRA(дBF8915AüĴA)
void BF8915A_wrcfga(uint8_t total_ic,ConfigA_TypeDef configAData[]);			

//Write the BF8915A CFGRB(дBF8915AüĴB)
void BF8915A_wrcfgb(uint8_t total_ic,ConfigB_TypeDef configBData[]);			

//Write the BF8915A CFGRC(дBF8915AüĴC)
void BF8915A_wrcfgc(uint8_t total_ic,ConfigC_TypeDef configCData[]);			

//Write the BF8915A CFGRD(дBF8915AüĴD)
void BF8915A_wrcfgd(uint8_t total_ic,ConfigD_TypeDef configDData[]);			

//Reads the BF8915A CFGRA register(BF8915AüĴA)
uint8_t BF8915A_rdcfga(uint8_t total_ic,ConfigA_TypeDef configAData[]);		

//Reads the BF8915A CFGRB register(BF8915AüĴB)
uint8_t BF8915A_rdcfgb(uint8_t total_ic,ConfigB_TypeDef configBData[]);		

//Reads the BF8915A CFGRC register(BF8915AüĴC)
uint8_t BF8915A_rdcfgc(uint8_t total_ic,ConfigC_TypeDef configCData[]);		

//Reads the BF8915A CFGRD register(BF8915AüĴD)
uint8_t BF8915A_rdcfgd(uint8_t total_ic,ConfigD_TypeDef configDData[]);	

// Reads the raw cell voltage register data(ȡԭʼصѹĴ)
void BF8915A_rdcv_reg(uint8_t reg,uint8_t total_ic,uint8_t *cellData);

//reads BF8915A GPIO registers(ȡBF8915AGPIOĴ)
void BF8915A_rdgv_reg(uint8_t reg,uint8_t total_ic,uint8_t *gpioData);

//Reads BF8915A stat registers(ȡBF8915A״̬Ĵ)
void BF8915A_rdstat_reg(uint8_t reg,uint8_t total_ic,uint8_t *statData);

//ADCV CMD(صѹADCתָ)
void BF8915A_adcv(uint8_t CLKSEL,uint8_t OSR,uint8_t DISCP,uint8_t CSEL); 

//ADCOW CMD(ضߵѹADCתָ)
void BF8915A_adcow(uint8_t CLKSEL,uint8_t OSR,uint8_t DISCP,uint8_t CSEL); 

//CVST CMD(صѹԲ)
void BF8915A_cvst(uint8_t CLKSEL,uint8_t OSR,uint8_t SFTEST);

//ADOL CMD(صԪָ)
void BF8915A_adol(uint8_t CLKSEL,uint8_t OSR,uint8_t DISCP);

//ADGP CMD(GPIO ADCתָ)
void BF8915A_adgp(uint8_t CLKSEL,uint8_t OSR,uint8_t GSEL);

//GPST CMD(GPIOԲָ)
void BF8915A_gpst(uint8_t CLKSEL,uint8_t OSR,uint8_t SFTEST);

//ADSTAT CMD(ڲ豸ָ)
void BF8915A_adstat(uint8_t CLKSEL,uint8_t OSR,uint8_t STSEL);

//STATST CMD(Բڲ豸ָ)
void BF8915A_statst(uint8_t CLKSEL,uint8_t OSR,uint8_t SFTEST);

//ADCVGP CMD(صѹGPIOָ)
void BF8915A_adcvgp(uint8_t CLKSEL,uint8_t OSR,uint8_t DISCP);

//MNT CMD(ָ)
void BF8915A_mnt(uint8_t CLKSEL, uint8_t OSR,uint8_t MNMOD,uint8_t STRMN,uint8_t BLEN);

//STRBL CMD(ָ)
void BF8915A_strbl(uint8_t CLKSEL,uint8_t OSR,uint8_t OESEL,uint8_t BLEN);

//Clear Cell Register(ԪĴ)
void BF8915A_clrcell(void);

//Clear GPIO Register(GPIOĴ)
void BF8915A_clrgp(void);

//Clear STATE Register(״̬Ĵ)
void BF8915A_clrstat(void);

//PLADC CMD(ѯADCת״ָ̬)
uint8_t BF8915A_pladc(void);

//soft reset(λ)
void BF8915A_softrst(void);

//Helper function that parses voltage measurement registers(ѹĴĸ)
uint8_t parse_cells(uint8_t current_ic,uint8_t cell_reg,uint8_t cell_data[],uint16_t *cell_codes,uint8_t *ic_pec);

//Reads and parses the BF8915A cell voltage registers(ȡͽBF8915AصѹĴ)
uint8_t BF8915A_rdcv(uint8_t reg,uint8_t total_ic,CellVoltage_TypeDef *cellVoltage);

//Reads and parses the BF8915A GPIO registers(ȡͽBF8915AGPIOĴ)
uint8_t BF8915A_rdgv(uint8_t reg,uint8_t total_ic,GPIOReg_TypeDef *gpioVoltage);

//Reads and parses the BF8915A stat registers(ȡͽBF8915A״̬Ĵ)
uint8_t BF8915A_rdstat(uint8_t reg,uint8_t total_ic,StateReg_TypeDef *stateReg);

#endif
